#set -x
file=/tmp/$$

if [ -L /config/dropbear ] ; then
    rm -r /config/dropbear
fi

check_model() {
  MODEL="Xilinx"
  if [ -e "/usr/bin/manufacturer" ]; then
    MODEL="$( cat /usr/bin/manufacturer )"
  fi
}

patch_files() {
    sleep 10
    chmod +x hpatchz
    ./hpatchz uramdisk_19.image.gz 19-17_patch_uramdisk.image.gz uramdisk_17.image.gz > /dev/null 2>&1
}

check_files() {
  md5sum -c fileinfo
  vres=$?
  if [ $vres -eq 1 ]; then
    echo "RUNME: FileList SD Check Failed!!!" >> /tmp/upgrade_result
    exit 3
  fi
}

update_sd_xilinx() {
  sync; echo 1 > /proc/sys/vm/drop_caches
  mv -f uramdisk_19.image.gz /mnt/mmc/uramdisk_19.image.gz
  mv -f update_19.image.gz  /mnt/mmc/update_19.image.gz
  mv -f uramdisk_17.image.gz /mnt/mmc/uramdisk_17.image.gz
  mv -f update_17.image.gz  /mnt/mmc/update_17.image.gz
  mv -f upgrade.tar.gz  /mnt/mmc/upgrade.tar.gz
  mv -f uEnv.txt  /mnt/mmc/uEnv.txt
  mv -f fileinfo  /mnt/mmc/fileinfo
  sleep 5
}

update_sd_bb() {
  sync; echo 1 > /proc/sys/vm/drop_caches
  mv -f uramdisk_BB.image.gz /mnt/mmc/uramdisk_BB.image.gz
  mv -f update.image.gz  /mnt/mmc/update.image.gz
  mv -f upgrade.tar.gz  /mnt/mmc/upgrade.tar.gz
  mv -f fileinfo  /mnt/mmc/fileinfo
  sleep 5
}

delete_files() {
  rm -rf /config/scanfreqdone 2>/dev/null
  if [ -e "/nvdata/latest.tar.gz" ]; then
    rm "/nvdata/latest.tar.gz" 2>/dev/null
  fi
  rm -rf /hive-config/model 2>/dev/null
  sync
}

migration() {
  ./rig-conf-migration.sh > /dev/null 2>&1
}

check_model
if [ "$MODEL" == "Xilinx" ]; then
  patch_files
  check_files
  update_sd_xilinx
  delete_files
elif [ "$MODEL" == "AM335x BeagleBone" ]; then
  check_files
  update_sd_bb
  delete_files
fi

migration


rm -rf /config/scanfreqdone 2>/dev/null
if [ -e "/nvdata/latest.tar.gz" ]; then
  rm "/nvdata/latest.tar.gz" 2>/dev/null
fi
sync >/dev/null 2>&1
